﻿using System;
using System.Web.UI;
using DevExpress.Web.ASPxTabControl;
using ThinkGeo.MapSuite.Core;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
            Map1.CurrentExtent = new RectangleShape(-180, 90, 180, -89);
            Map1.MapUnit = GeographyUnit.DecimalDegree;
            Map1.MapTools.PanZoomBar.Enabled = true;
            Map1.MapTools.OverlaySwitcher.Enabled = true;
        }
    }

    protected void btnStore_Click(object sender, EventArgs e)
    {
        ViewState["filePath"] = txtPath.Text;
        ViewState["extent"] = ConvertStringToExtent(txtExtent.Text);

        ScriptManager.RegisterStartupScript(UpdatePanel1, typeof(UpdatePanel), "onload", "alert('Stored!');", true);
    }

    protected void ASPxPageControl1_ActiveTabChanged(object source, DevExpress.Web.ASPxTabControl.TabControlEventArgs e)
    {
        if (e.Tab.Index == 1)
        {
            LoadMap();
        }
    }

    private void LoadMap()
    {
        string filePath = ViewState["filePath"].ToString();
        RectangleShape currentExtent = ViewState["extent"] as RectangleShape;

        ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(filePath);
        worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
        worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

        Map1.CurrentExtent = currentExtent;
        Map1.StaticOverlay.Layers.Add(worldLayer);
        Map1.StaticOverlay.Redraw();
    }

    private RectangleShape ConvertStringToExtent(string str)
    {
        string[] values = str.Split(',');
        RectangleShape rec = new RectangleShape(int.Parse(values[0]), int.Parse(values[1]), int.Parse(values[2]), int.Parse(values[3]));

        return rec;
    }
}
